//+------------------------------------------------------------------+
//|                                                 Crazy_Candle.mq4 |
//|                               Copyright  2007, Nondisclosure007 |
//|                                               http://no.link.yet |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Nondisclosure007"
#property link      "http://no.link.yet"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 DodgerBlue
#property indicator_color2 Red

extern double  bodyPercent = 50; //Percentage of 'real body' candle for calculation.
extern double  wickPercent = 10; //Percentage of the small wick to open an order.

double goingUp[];
double goingDown[];

int init()
  {
   SetIndexStyle(0, DRAW_ARROW, EMPTY);
   SetIndexArrow(0, 233);
   SetIndexBuffer(0, goingUp);
   SetIndexStyle(1, DRAW_ARROW, EMPTY);
   SetIndexArrow(1, 234);
   SetIndexBuffer(1, goingDown);
   SetIndexLabel(0,"goingUp");
   SetIndexLabel(1,"goingDown");

   return(0);
  }
int deinit()
  {
   
   return(0);
  }

int start()
{
   int    counted_bars=IndicatorCounted();
   int limit,counter;
   double bdyPerc,wckPerc,haOpen,haClose,ha1,ha2,haHigh,haLow,upper5,lower5,upper8,lower8,range,avgRange;
   double tempOC,tempHL, tempT;
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   
   for(int i=1; i <= limit; i++) 
   {
      bdyPerc=bodyPercent/100;
      wckPerc=wickPercent/100;
   
      //get Heiken Ashi values
      haOpen=iCustom(NULL,0,"Heiken_Ashi",2,i);
      haClose=iCustom(NULL,0,"Heiken_Ashi",3,i);
      ha1=iCustom(NULL,0,"Heiken_Ashi",0,i);
      ha2=iCustom(NULL,0,"Heiken_Ashi",1,i);
   
      //get MA (Price Action Channel PAC for all of you Synergy lovers out there).
      upper5=iMA(NULL,0,5,0,MODE_SMMA,PRICE_HIGH,i);
      lower5=iMA(NULL,0,5,0,MODE_SMMA,PRICE_LOW,i);
      upper8=iMA(NULL,0,8,0,MODE_EMA,PRICE_HIGH,i);
      lower8=iMA(NULL,0,8,0,MODE_EMA,PRICE_LOW,i);

      counter=i;
      range=0;
      avgRange=0;
      for (counter=i ;counter<=i+9;counter++)
      {
         avgRange=avgRange+MathAbs(High[counter]-Low[counter]);
      }
      range=avgRange/10;
   
      //set haHigh and haLow (High and Low for Heiken Ashi candle)
      if (ha1>ha2)
      {
         haHigh=ha1;
         haLow=ha2;
      }
      if (ha1<ha2)
      {
         haHigh=ha2;
         haLow=ha1;
      }
      //see if 'real body' is greater than 50% of the entire candle

      tempOC=MathAbs(haOpen-haClose);
      tempHL=MathAbs(haHigh-haLow);
      tempT=tempOC/tempHL;
      if ((MathAbs(tempOC)/MathAbs(tempHL))<=bdyPerc) 
      {
         return(0);
      }
   
      //check long vs short on 5EMA and 8SMA
      if (haClose>upper5 && haClose>upper8)
      {
         if (haOpen-haLow<haHigh-haClose)
         {
            if (haOpen-haLow/((haOpen-haLow)+(haHigh-haClose))<wckPerc)
            {
               goingUp[i]=Low[i]-range*0.5;
            }
         }
      }
      else if (haClose<lower5 && haClose<lower8)
      {
         if (haHigh-haOpen<haClose-haLow)
        {
            if (haHigh-haOpen/((haHigh-haOpen)+(haClose-haLow))<wckPerc)
            {
               goingDown[i]=High[i]+range*0.5;
            }
         }  
      }   
   }
   return(0);
}

